%define name suspend
%define version 0.8
%define cvs 20080612
%define rel 12
%if %{cvs}
%define distname %{name}-%{version}.%{cvs}
%define release %mkrel %{rel}.%{cvs}
%else
%define distname %{name}-%{version}
%define release %mkrel %{rel}
%endif

# Not really used yet, so disable for now
%bcond_with	uclibc

Summary: Userland tools for suspend-to-disk and suspend-to-RAM
Name: %{name}
Version: %{version}
Release: %{release}
Source0: http://prdownloads.sourceforge.net/%{name}/%{distname}.tar.bz2

#- opensuse patches
Patch1: suspend-comment-configfile-options.diff
# not needed in Mandriva
#Patch2: suspend-susescripts.diff
Patch3: suspend-default-compress.diff
# no more bootsplash in kernel and thus no /proc/splash, patch not needed
#Patch4: suspend-disable-bootsplash.diff
Patch5: suspend-default-splash.diff
# user interruption could be considered as an error, don't apply
#Patch6: suspend-0.80-dont-return-eintr-on-abort.diff
Patch10: suspend-use-input-device.diff
# we don't test whitelist
#Patch11: suspend-0.80-make-whitelist-test.diff
# not needed, builds fine
#Patch12: suspend-buildfixes.diff
Patch13: suspend-0.80-vbetool-retry-on-errors.diff
Patch14: suspend-multithreaded-image-saving.diff
Patch15: suspend-0.80-suspend-output-to-logfile.diff
# we don't use bootsplash, not needed
#Patch16: suspend-splash-verbose-debug.diff
Patch70: suspend-0.80-whitelist-openSUSE11.diff
# opensuse-specific
#Patch99: suspend-0.80-opensuse.org.diff

#- Mandriva patches
Patch100: suspend-0.8-no_s2ram_quirks.patch
Patch101: suspend-0.5-bootsplash.patch
Patch102: suspend-0.8.20080612-mdvcomment.patch
Patch103: suspend-0.8-printf_format.patch
# (blino) kill splashy before resume binary starts it
Patch104: suspend-0.8.20080612-stopsplashy.patch
# (fc) plymouth support
Patch105: suspend-plymouth.patch
# (proyvind): to get _GNU_SOURCE defined, fixes build with uclibc
Patch106: suspend-0.8.20080612-configure-gnu-source.patch
# (pt) fix resume when splash = n in suspend.conf
Patch107: suspend-plymouth-always-quit.patch

License: GPLv2
Group: System/Kernel and hardware
Url: http://suspend.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: pciutils-devel libx86-devel liblzo-devel 
BuildRequires: zlib-devel
# (tv) fix upgrade ordering (libpci3 needs to be updaded from 3.0 to 3.1 before ldetect is upgraded):
Requires: %{mklibname pci 3} >= 3.1
ExcludeArch: ppc
Obsoletes: wltool
Obsoletes: suspend-wltool
Requires(post): drakxtools-backend >= 10.4.97-1mdv2007.1
Requires(post): mkinitrd >= 4.2.17-27mdv2007.1
BuildRequires: plymouth-devel >= 0.7.2
%if %{with uclibc}
BuildRequires: uClibc-devel
%endif

%description
The goal of the project is to create a tool that can handle the so
called "suspend-to-both". Suspend to both means that prior putting the
system in STR (suspend to ram) a snapshot of the running system is
taken and stored on disk (as suspend to disk); if for any reason
(e.g. battery depleted) the state store in the RAM is lost the user
can resume from the disk without loosing data.

Currenty suspend-to-ram and suspend-to-disk are handled by two
different program, s2ram and s2disk.

%package s2ram
Summary: Suspend-to-RAM utility
Group: System/Kernel and hardware
Conflicts: suspend < 0.5-4mdv2007.1

%description s2ram
s2ram is a suspend-to-RAM utility.

%prep
%setup -q -n %{distname}
#- opensuse patches
%patch1 -p1
#%patch2 -p0
%patch3 -p0
#%patch4 -p0
%patch5 -p0
#%patch6 -p1
%patch10 -p1
#%patch11 -p0
#%patch12 -p0
%patch13 -p0
%patch14 -p1
%patch15 -p1
#%patch16 -p1
%patch70 -p1
#%patch99 -p1

#- Mandriva patches
%patch100 -p1 -b .no_s2ram_quirks
%patch101 -p1 -b .bootsplash
%patch102 -p1 -b .mdvcomment
%patch103 -p1 -b .printf_format
%patch104 -p1 -b .stopsplashy
%patch105 -p1 -b .plymouth
%patch106 -p1 -b .gnu_source~
%patch107 -p1 -b .plymouth-quit

#needed by patch105
libtoolize --force
autoreconf
%build
export CONFIGURE_TOP=`pwd`
%if %{with uclibc}
mkdir -p uclibc
cd uclibc
%configure2_5x \
  CC="%{uclibc_cc}" \
  CFLAGS="%{uclibc_cflags}" \
  --enable-compress \
  --enable-plymouth \
  --enable-threads \
  --disable-resume-static
%make
cd ..
%endif

mkdir -p shared
cd shared
%configure2_5x \
  --enable-compress \
  --enable-plymouth \
  --enable-threads \
  --disable-resume-static
%make
cd ..

%install
rm -rf %{buildroot}
install -d %{buildroot}{,%{uclibc_root}}%{_sbindir}
install -d %{buildroot}%{_sysconfdir}
%if %{with uclibc}
install -m755 uclibc/resume -D %{buildroot}%{uclibc_root}%{_libdir}/%{name}/resume
ln -sf %{uclibc_root}%{_libdir}/%{name}/resume %{buildroot}%{uclibc_root}%{_sbindir}/resume
%endif

%makeinstall_std -C shared
ln -sf %{_libdir}/%{name}/resume %{buildroot}%{_sbindir}

%clean
rm -rf %{buildroot}

%post
/usr/sbin/bootloader-config --action rebuild-initrds || :

%files
%defattr(-,root,root)
%doc HOWTO README README.s2ram-whitelist TODO
%{_sbindir}/resume
%{_sbindir}/s2both
%{_sbindir}/s2disk
%{_sbindir}/swap-offset
%{_libdir}/%{name}/resume
%config(noreplace) %{_sysconfdir}/%{name}.conf
%if %{with uclibc}
%{uclibc_root}%{_sbindir}/resume
%{uclibc_root}%{_libdir}/%{name}/resume
%endif

%files s2ram
%defattr(-,root,root)
%{_sbindir}/s2ram


%changelog
* Fri May 06 2011 Oden Eriksson <oeriksson@mandriva.com> 0.8-12.20080612mdv2011.0
+ Revision: 670250
- mass rebuild

* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 0.8-11.20080612mdv2011.0
+ Revision: 607758
- rebuild

* Wed May 26 2010 Pascal Terjan <pterjan@mandriva.org> 0.8-10.20080612mdv2010.1
+ Revision: 546161
- fix resume when splash = n in suspend.conf

* Wed Apr 21 2010 Frederic Crozat <fcrozat@mandriva.com> 0.8-9.20080612mdv2010.1
+ Revision: 537679
- Update plymouth patch to work with plymouth 0.8.x

  + Luis Daniel Lucio Quiroz <dlucio@mandriva.org>
    - BR fix
    - Rebuild

* Wed Mar 17 2010 Oden Eriksson <oeriksson@mandriva.com> 0.8-8.20080612mdv2010.1
+ Revision: 524138
- rebuilt for 2010.1

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - disable uClibc build for now
    - really use same layout for uclibc root
    - build uclibc linked resume binary
    - correct license tag

* Wed Sep 09 2009 Frederic Crozat <fcrozat@mandriva.com> 0.8-6.20080612mdv2010.0
+ Revision: 435629
- Improve plymouth patch to no hide text when plymouth isn't install

* Mon Sep 07 2009 Frederic Crozat <fcrozat@mandriva.com> 0.8-5.20080612mdv2010.0
+ Revision: 432674
- Patch105: add support for plymouth
- switch to plymouth

* Tue Sep 01 2009 Thierry Vignaud <tv@mandriva.org> 0.8-4.20080612mdv2010.0
+ Revision: 423621
- fix upgrade ordering (libpci3 needs to be updaded from 3.0 to 3.1 before
  ldetect is upgraded) (#53347)
- fix build

* Fri Mar 27 2009 Olivier Blin <oblin@mandriva.com> 0.8-3.20080612mdv2009.1
+ Revision: 361593
- kill splashy before resume binary starts it (#44639)

* Wed Feb 04 2009 Andrey Borzenkov <arvidjaar@mandriva.org> 0.8-2.20080612mdv2009.1
+ Revision: 337346
- BuildRequires zlib-devel
- actually add printf format fixes
- patch103 - fix printf format errors
- rediff fuzzy patch101
- rediff fuzzy patch100

* Fri Sep 12 2008 Olivier Blin <oblin@mandriva.com> 0.8-1.20080612mdv2009.0
+ Revision: 284200
- remove unwanted comments in config file from opensuse patch
- do not require glibc-static-devel, resume binary is not static anymore (thanks spuk)
- whitelist update for MacBook1,1 (for kernel >= 2.6.25, from opensuse)
- more verbose logging to stderr -> pm-utils logfile (from opensuse)
- workaround temporary vbetool failures (patch from opensuse)
- read keyboard events from /dev/input instead of stdin, to cope with splashy (from CVS/opensuse)
- enable compression by default (from opensuse)
- add mulithreaded image saving patch (from opensuse)
- add config file comments patch from opensuse (maybe not totally relevant, but needed to apply cleanly multithreading patch)
- use opensuse patch to enable splash by default
- update doc files list
- drop merged splashy detection patch
- update to cvs snapshot 20080612 (from opensuse package)

* Thu Sep 04 2008 Olivier Blin <oblin@mandriva.com> 0.8-1mdv2009.0
+ Revision: 280474
- build dynamic resume binary (static splashy support would require a libgcc_s.a)
- fix splashy detection (from upstream CVS)
- enable splashy
- remove suspend dir hack, configure defaults to /usr/sbin
- remove old config hack for udev
- enable lzo compression
- package resume utility in its new location and add a compatibility symlink
- rediff no_s2ram_quirks patch (and keep including s2ram.h)
- buildrequire libx86-devel
- run configure
- 0.8

* Wed Jun 18 2008 Thierry Vignaud <tv@mandriva.org> 0.5-13mdv2009.0
+ Revision: 225538
- rebuild

* Wed Mar 05 2008 Oden Eriksson <oeriksson@mandriva.com> 0.5-12mdv2008.1
+ Revision: 179550
- rebuild

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request


* Fri Mar 23 2007 Olivier Blin <oblin@mandriva.com> 0.5-11mdv2007.1
+ Revision: 148234
- require recent enough drakxtools-backend and mkinitrd for post

* Sun Mar 11 2007 Olivier Blin <oblin@mandriva.com> 0.5-10mdv2007.1
+ Revision: 141302
- mark suspend.conf as config(noreplace) (thanks to couriousous)
- build with compression support (not enabled by default)

* Tue Feb 27 2007 Olivier Blin <oblin@mandriva.com> 0.5-8mdv2007.1
+ Revision: 126219
- do not allow post to fail because of bootloader-config

* Fri Feb 16 2007 Olivier Blin <oblin@mandriva.com> 0.5-6mdv2007.1
+ Revision: 121861
- rebuild initrds in post

* Mon Jan 22 2007 Olivier Blin <oblin@mandriva.com> 0.5-5mdv2007.1
+ Revision: 112044
- enable splash by default
- fix freeze during hibernate when bootsplash is enabled (patch from Arnaud Patard)

* Wed Jan 17 2007 Olivier Blin <oblin@mandriva.com> 0.5-4mdv2007.1
+ Revision: 110060
- do not try to run s2ram tricks in s2both, pm-utils scripts will handle video quirks
- move s2ram in a separate package, it should not be used by default
- drop wltool, it should be replaced by an initscript using hal-info
- drop unwanted splashy support
- write options in Makefile instead of passing them on command line

* Mon Dec 18 2006 Christiaan Welvaart <spturtle@mandriva.org> 0.5-3mdv2007.1
+ Revision: 98445
- don't try to build on ppc

* Wed Dec 13 2006 Olivier Blin <oblin@mandriva.com> 0.5-2mdv2007.1
+ Revision: 96321
- provides wltool as well

* Tue Dec 12 2006 Olivier Blin <oblin@mandriva.com> 0.5-1mdv2007.1
+ Revision: 95989
- buildrequires glibc-static-devel
- buildrequires glibc-devel
- add Z61m in whitelist (settings from Frederic Crozat)
- merge with wltool package
- rediff patch1
- add D420 in whitelist (settings from Arnaud Patard)
- BuildRequires pciutils-devel
- add dummy whitelist entry (from wltool)
- initial suspend release
- Create suspend

